/* Server
*  We write the server first because we need its IP address
*/

#include <ESP8266WiFi.h>
#include <WiFiClient.h> 
#include <ESP8266WebServer.h>




#define LED_A  12
#define LED_B  13
#define LED_C  15

#define Sound_pin 5

#define Con_LED 4

#define TL_A   16
#define TL_B   14
#define TL_C   2

uint16_t Led_Time  = 200;

uint8_t  A_Status;
uint8_t  B_Status;
uint8_t  C_Status;

uint8_t  A_Request;
uint8_t  B_Request;
uint8_t  C_Request;
String content;
int statusCode;

uint16_t Loop_Counter;

uint16_t Led_A_Counter;
uint16_t Led_B_Counter;
uint16_t Led_C_Counter;

uint8_t TL_A_used;
uint8_t TL_B_used;
uint8_t TL_C_used;

uint8_t Status_Copy;
uint8_t xxx;

uint8_t Beep_A_used;
uint8_t Beep_B_used;
uint8_t Beep_C_used;

uint16_t Beep_A_Counter;
uint16_t Beep_B_Counter;
uint16_t Beep_C_Counter;



const char* ssid = "My_Leds";       // ssid of server (Access Point (AP))
const char* password = "microgram";        // password of server (Access Point (AP))


ESP8266WebServer server(80);

int ledPin = 2; // GPIO2 of Server ESP8266


//...................................................... setup begin ............................................................................
void setup() 
{
	//digitalWrite(Con_LED,HIGH);
   // delay(500);
	//digitalWrite(Con_LED,LOW);
	//delay(500);
	
    Serial.begin(115200);    // to use tools->serial monitor

    pinMode(LED_A, OUTPUT);
	pinMode(LED_B, OUTPUT);
	pinMode(LED_C, OUTPUT);
	
	pinMode(Sound_pin, OUTPUT);
	digitalWrite(Sound_pin,LOW);
	
	pinMode(Con_LED, OUTPUT);
	
	pinMode(0, INPUT_PULLUP);

	pinMode(TL_A, INPUT_PULLUP);
	pinMode(TL_B, INPUT_PULLUP);
	pinMode(TL_C, INPUT_PULLUP);
	
    WiFi.mode(WIFI_AP_STA);  // Set WiFi to AP and station mode
	WiFi.mode(WIFI_STA);
	//WiFi.disconnect();
    WiFi.softAP(ssid, password);
	WiFi.begin();
	createWebServer();
	Serial.println();
	Serial.print("My IP Address: ");
	Serial.print(WiFi.softAPIP());
    Serial.println("/");
	
    server.begin();
    Serial.println("Server listening for incoming connections");
}  
//...................................................... setup end ............................................................................
//...................................................... loop begin ............................................................................
void loop() 
{	

	delay(300);	
    server.handleClient(); 	
	
	if (Led_A_Counter > 0)
	{
		digitalWrite(LED_A,HIGH);
		A_Status = 1;
		Led_A_Counter --;
	}
	else
	{
		digitalWrite(LED_A,LOW);
		A_Status = 0;
	}
	
	if (Led_B_Counter > 0)
	{
		digitalWrite(LED_B,HIGH);
		B_Status = 1;
		Led_B_Counter --;
	}
	else
	{
		digitalWrite(LED_B,LOW);
		B_Status = 0;
	}
	
	if (Led_C_Counter > 0)
	{
		digitalWrite(LED_C,HIGH);
		C_Status = 1;
		Led_C_Counter --;
	}
	else
	{
		digitalWrite(LED_C,LOW);
		C_Status = 0;
	}
	
	
	xxx = Scan_Keys();	
	Status_Copy = Status_Copy | xxx;
	Server_Status_Eval();
		
	Beep_Function();

	Loop_Counter ++;
	
	if(Loop_Counter > 20)
	{
		digitalWrite(Con_LED,LOW);   //dlouho nebyl dotaz Loop_Counter se resetuje, pokud prijde zprava od klienta
		
		//Serial.println(Loop_Counter);
	}
	else
	{
		digitalWrite(Con_LED,HIGH);
	}
}
//.......................................................... loop end .............................................................................
//------------------------------------------------- Beep_Function ---------------------------------------------------------------------
void  Beep_Function()
{
	if((Led_Time - Led_A_Counter) <  4)
	{
		Beep(800,300);
	}
		
	if((Led_Time - Led_B_Counter) <  4)
	{
		Beep(1150,300);
	}
	
	if((Led_Time - Led_C_Counter) <  4)
	{
		Beep(1500,300);
	}
}
//------------------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------- createWebServer ----------------------------------------------------------------------
void createWebServer(void)
{

    server.on("/", []() 
	{
    content = "Nazdar"; 
   // Serial.println("Connected");
    server.send(200, "text/html", content);
    });
	
    server.on("/setting", []() 
	{
    content = "Success, data saved.";
    statusCode = 200;       
    
    server.send(statusCode, "text/html", content);
    });
	server.on("/control", []() 
	{	
		Loop_Counter = 0;
	
		Serial.print("LED_A: ");
		Serial.println(A_Status);
		Serial.print("LED_B: ");
		Serial.println(B_Status);
		Serial.print("LED_C: ");
		Serial.println(C_Status);
				
		content = "LED_A: ";
		content += String(A_Status);
		content += ", LED_B: ";
		content += String(B_Status);
		content += ", LED_C: ";
		content += String(C_Status);
		content += "#";
    
    statusCode = 200;       
    
    server.send(statusCode, "text/html", content);
    });
	
	server.on("/data", []() 
	{
		Loop_Counter = 0;
		
		String Req_A = server.arg("LED_A");
		String Req_B = server.arg("LED_B");
		String Req_C = server.arg("LED_C");
		
		Serial.print("LED_A: ");
		Serial.println(Req_A);
		Serial.print("LED_B: ");
		Serial.println(Req_B);
		Serial.print("LED_C: ");
		Serial.println(Req_C);
		
		if (Req_A == "ON")
		{
			A_Request = 1;
			Led_A_Counter = Led_Time;
			A_Status = 1;
		}
		else
		{
			A_Request = 0;
		}
		
		if (Req_B == "ON")
		{
			B_Request = 1;
			Led_B_Counter = Led_Time;
			B_Status = 1;
		}
		else
		{
			B_Request = 0;
		}
		
		if (Req_C == "ON")
		{
			C_Request = 1;
			Led_C_Counter = Led_Time;
			C_Status = 1;
		}
		else
		{
			C_Request = 0;
		}		
		
		content = "LED_A: ";
		content += String(A_Status);
		content += ", LED_B: ";
		content += String(B_Status);
		content += ", LED_C: ";
		content += String(C_Status);
		content += "#";
    statusCode = 200;       
    
    server.send(statusCode, "text/html", content);
    });	
}		
//------------------------------------------------------------------------------------------------------------------------------------
//------------------------------------------------ Scan_Keys ----------------------------------------------------------------------------------------
uint8_t Scan_Keys(void)
{
	uint8_t All_TL_Status = 0;
	
	if(digitalRead(TL_A) == LOW)
	{
		if(TL_A_used == 0)
		{	
		 All_TL_Status += 1; 
	     TL_A_used = 1;	 
		}
	}
	else
	{
		TL_A_used = 0;
	}
	if(digitalRead(TL_B) == LOW)
	{
		if(TL_B_used == 0)
		{
		 All_TL_Status += 2; 
	     TL_B_used = 1;
		}
	}
	else
	{
		TL_B_used = 0;
	}
	
	if(digitalRead(TL_C) == LOW)
	{
		if(TL_C_used == 0)
		{
		 All_TL_Status += 4; 
	     TL_C_used = 1;
		}
	}
	else
	{
		TL_C_used = 0;
	}
	return All_TL_Status;	
}
//---------------------------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------- Beep  ------------------------------------------------------------------------------------
void  Beep(uint16_t freqency, uint16_t _time)
{
		 tone(Sound_pin, freqency);
		 delay(_time);
		 noTone(Sound_pin);	
}
//---------------------------------------------------------------------------------------------------------------------------------------------------
//------------------------------------------------- Server_Status_Eval ------------------------------------------------------------------------------
void  Server_Status_Eval(void)	
{	
	if (Status_Copy != 0)
	{
		if ((Status_Copy & 0x01) != 0)
		{
		   	Status_Copy &= 0xFE;      // vynuluj indikator
			Led_A_Counter = 0;
		}
		else
		{
			
		}
		
		if ((Status_Copy & 0x02) != 0)
		{
		   	Status_Copy &= 0xFD;      // vynuluj indikator
			Led_B_Counter = 0;
		}
		else
		{
			
		}
		
		if ((Status_Copy & 0x04) != 0)
		{
		   	Status_Copy &= 0xFB;      // vynuluj indikator
			Led_C_Counter = 0;
		}
		else
		{
			
		}
		
	}
}	
//---------------------------------------------------------------------------------------------------------------------------------------------------





